"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.JsonNode = void 0;
const Node_1 = require("../../nodes/Node");
exports.JsonNode = () => {
    return {
        ...Node_1.Base,
        default: () => '',
        render(path, value, view, options) {
            var _a, _b, _c, _d;
            const stringified = ((_a = JSON.stringify(value)) !== null && _a !== void 0 ? _a : '').replace(/"/g, '&quot;');
            const onChange = view.registerChange(el => {
                const value = el.value;
                try {
                    view.model.set(path, JSON.parse(value));
                }
                catch (e) {
                    view.model.set(path, value || undefined);
                }
            });
            return `<div class="node json-node node-header" ${path.error()}>
        ${(_b = options === null || options === void 0 ? void 0 : options.prepend) !== null && _b !== void 0 ? _b : ''}
        <label>${(_c = options === null || options === void 0 ? void 0 : options.label) !== null && _c !== void 0 ? _c : path.locale()}</label>
        ${(_d = options === null || options === void 0 ? void 0 : options.inject) !== null && _d !== void 0 ? _d : ''}
        <input data-id="${onChange}" value="${stringified !== null && stringified !== void 0 ? stringified : ''}">
      </div>`;
        },
        validate(path, value, errors) {
            if (value == undefined) {
                errors.add(path, 'error.expected_json');
            }
            return value;
        }
    };
};
