"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const AbstractNode_1 = require("../../nodes/AbstractNode");
const TreeView_1 = require("../../view/TreeView");
const Registries_1 = require("../../Registries");
class JsonStringNode extends AbstractNode_1.AbstractNode {
    constructor(mods) {
        super(mods);
    }
    getState(el) {
        const value = el.querySelector('input').value;
    }
    renderRaw(path, value, view, options) {
        var _a;
        const id = `datalist-${TreeView_1.getId()}`;
        return `${((_a = options) === null || _a === void 0 ? void 0 : _a.hideLabel) ? `` : `<label>${Registries_1.locale(path)}</label>`}
    <input list=${id} value="${(value !== null && value !== void 0 ? value : '')}">
    <datalist id=${id}>${this.options.map(o => `<option value="${o}">${Registries_1.locale(path.push(o))}</option>`).join('')}</datalist>`;
    }
    getClassName() {
        return 'json-node';
    }
}
exports.JsonStringNode = JsonStringNode;
