import { INode } from '../../nodes/Node';
export declare type IRange = number | {
    min?: number;
    max?: number;
    type?: 'uniform';
} | {
    n?: number;
    p?: number;
    type: 'binomial';
};
declare type RangeNodeConfig = {
    /** Whether only integers are allowed */
    integer?: boolean;
    /** If specified, number will be capped at this minimum */
    min?: number;
    /** If specified, number will be capped at this maximum */
    max?: number;
    /** Whether binomials are allowed */
    allowBinomial?: boolean;
    /** If true, only ranges are allowed */
    forceRange?: boolean;
};
export declare const RangeNode: (config?: RangeNodeConfig | undefined) => INode<IRange>;
export {};
