import { Path } from "./Path";
export declare type PathError = {
    path: Path;
    error: string;
    params?: any[];
};
/**
 * Collects errors from data paths
 */
export declare class Errors implements Iterable<PathError> {
    private errors;
    add(path: Path, error: string, ...params: any): false;
    get(path: Path, exact?: boolean): PathError[];
    getAll(): PathError[];
    clear(): void;
    count(): number;
    [Symbol.iterator](): Generator<PathError, void, unknown>;
}
