"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ListNode = void 0;
const Node_1 = require("./Node");
exports.ListNode = (children, config) => {
    return ({
        ...Node_1.Base,
        transform(path, value, view) {
            if (!(value instanceof Array))
                return value;
            return value.map((obj, index) => children.transform(path.push(index), obj, view));
        },
        render(path, value, view, options) {
            var _a, _b, _c;
            value = value !== null && value !== void 0 ? value : [];
            const onAdd = view.registerClick(el => {
                if (!(value instanceof Array))
                    value = [];
                view.model.set(path, [...value, children.default()]);
            });
            return `<div class="node list-node">
        <div class="node-header" ${path.error()}>
          ${(_a = options === null || options === void 0 ? void 0 : options.prepend) !== null && _a !== void 0 ? _a : ''}
          <label>${(_b = options === null || options === void 0 ? void 0 : options.label) !== null && _b !== void 0 ? _b : path.locale()}</label>
          ${(_c = options === null || options === void 0 ? void 0 : options.inject) !== null && _c !== void 0 ? _c : ''}
          <button class="add" data-id="${onAdd}"></button>
        </div>
        ${!(value instanceof Array) ? `` :
                `<div class="node-body">
          ${(value !== null && value !== void 0 ? value : []).map((obj, index) => {
                    const removeId = view.registerClick(el => view.model.set(path.push(index), undefined));
                    return `<div class="node-entry">
            ${children.render(path.push(index).localePush('entry'), obj, view, {
                        prepend: `<button class="remove" data-id="${removeId}"></button>`,
                        label: path.localePush('entry').locale()
                    })}
          </div>`;
                }).join('')}
        </div>`}
      </div>`;
        },
        validate(path, value, errors, options) {
            if (options.loose && value === undefined) {
                return [];
            }
            if (!(value instanceof Array)) {
                errors.add(path, 'error.expected_list');
                return value;
            }
            if (!(config === null || config === void 0 ? void 0 : config.allowEmpty) && value.length === 0) {
                if (options.loose) {
                    return undefined;
                }
                else {
                    errors.add(path, 'error.invalid_empty_list');
                }
            }
            return value.map((obj, index) => children.validate(path.push(index), obj, errors, options));
        }
    });
};
