"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.NumberNode = void 0;
const Node_1 = require("./Node");
exports.NumberNode = (config) => {
    var _a, _b, _c;
    const integer = (_a = config === null || config === void 0 ? void 0 : config.integer) !== null && _a !== void 0 ? _a : false;
    const min = (_b = config === null || config === void 0 ? void 0 : config.min) !== null && _b !== void 0 ? _b : -Infinity;
    const max = (_c = config === null || config === void 0 ? void 0 : config.max) !== null && _c !== void 0 ? _c : Infinity;
    const between = (config === null || config === void 0 ? void 0 : config.min) !== undefined && (config === null || config === void 0 ? void 0 : config.max) !== undefined;
    return {
        ...Node_1.Base,
        default: () => 0,
        render(path, value, view, options) {
            var _a, _b, _c;
            const onChange = view.registerChange(el => {
                const value = el.value;
                let parsed = integer ? parseInt(value) : parseFloat(value);
                view.model.set(path, parsed);
            });
            return `<div class="node number-node node-header" ${path.error()}>
        ${(_a = options === null || options === void 0 ? void 0 : options.prepend) !== null && _a !== void 0 ? _a : ''}
        <label>${(_b = options === null || options === void 0 ? void 0 : options.label) !== null && _b !== void 0 ? _b : path.locale()}</label>
        ${(_c = options === null || options === void 0 ? void 0 : options.inject) !== null && _c !== void 0 ? _c : ''}
        <input data-id="${onChange}" value="${value !== null && value !== void 0 ? value : ''}">
      </div>`;
        },
        validate(path, value, errors) {
            if (typeof value !== 'number') {
                errors.add(path, 'error.expected_number');
            }
            else if (integer && !Number.isInteger(value)) {
                errors.add(path, 'error.expected_integer');
            }
            else if (between && (value < min || value > max)) {
                errors.add(path, 'error.expected_number_between', min, max);
            }
            else if (value < min) {
                errors.add(path, 'error.invalid_range.smaller', value, min);
            }
            else if (value > max) {
                errors.add(path, 'error.invalid_range.larger', value, max);
            }
            return value;
        }
    };
};
