import { INode } from './Node';
import { Path } from '../model/Path';
export declare const Switch: unique symbol;
export declare const Case: unique symbol;
export declare type NodeChildren = {
    [name: string]: INode;
};
export declare type NestedNodeChildren = {
    [name: string]: NodeChildren;
};
export declare type IObject = {
    [name: string]: any;
};
export declare type FilteredChildren = {
    [name: string]: INode;
    /** The field to filter on */
    [Switch]?: (path: Path) => Path;
    /** Map of filter values to node fields */
    [Case]?: NestedNodeChildren;
};
declare type ObjectNodeConfig = {
    allowEmpty?: boolean;
    collapse?: boolean;
    context?: string;
    disableSwitchContext?: boolean;
    category?: string;
};
export declare const ObjectNode: (fields: FilteredChildren, config?: ObjectNodeConfig | undefined) => INode<IObject>;
export {};
